"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "QinCore", {
  enumerable: true,
  get: function get() {
    return _QinCore.default;
  }
});
Object.defineProperty(exports, "QinSandbox", {
  enumerable: true,
  get: function get() {
    return _QinSandbox.default;
  }
});
Object.defineProperty(exports, "QinRenderer", {
  enumerable: true,
  get: function get() {
    return _QinRenderer.default;
  }
});
Object.defineProperty(exports, "QinScene", {
  enumerable: true,
  get: function get() {
    return _QinScene.default;
  }
});
exports.Qin = void 0;

require("core-js/modules/es6.object.define-property");

require("core-js/modules/es6.function.name");

require("core-js/modules/es6.promise");

require("regenerator-runtime/runtime");

var _QinCore = _interopRequireDefault(require("./core/QinCore"));

var _QinSandbox = _interopRequireDefault(require("./core/QinSandbox"));

var _QinRenderer = _interopRequireDefault(require("./render/QinRenderer"));

var _QinScene = _interopRequireDefault(require("./render/QinScene"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * class for creating Qin instance
 */
var Qin =
/*#__PURE__*/
function () {
  /**
   * create Qin instance
   * @param props {Object} QinPropsType
   * @param props.element {HTMLElement} html element to let Qin knows where to add canvas
   * @param props.isDebugRedux {boolean} turn on debugging for redux store
   */
  function Qin(props) {
    _classCallCheck(this, Qin);

    _defineProperty(this, "_core", void 0);

    _defineProperty(this, "_renderer", void 0);

    this._core = new _QinCore.default({
      isDebugRedux: props.isDebugRedux
    });
    this._renderer = new _QinRenderer.default({
      core: this._core,
      element: props.element,
      width: props.width,
      height: props.height
    });
  }

  _createClass(Qin, [{
    key: "loadSandBox",
    value: function loadSandBox(sandBox) {
      this._core.setSandBox(sandBox);
    }
  }, {
    key: "loadScene",
    value: function loadScene(scene) {}
  }, {
    key: "createSandbox",
    value: function () {
      var _createSandbox = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(sandboxInfo) {
        var _this = this;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                return _context2.abrupt("return", new Promise(
                /*#__PURE__*/
                function () {
                  var _ref = _asyncToGenerator(
                  /*#__PURE__*/
                  regeneratorRuntime.mark(function _callee(resolve, reject) {
                    return regeneratorRuntime.wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            _context.prev = 0;
                            _context.next = 3;
                            return _this._core.desertify(sandboxInfo.name);

                          case 3:
                            resolve();
                            _context.next = 9;
                            break;

                          case 6:
                            _context.prev = 6;
                            _context.t0 = _context["catch"](0);
                            reject(_context.t0);

                          case 9:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee, this, [[0, 6]]);
                  }));

                  return function (_x2, _x3) {
                    return _ref.apply(this, arguments);
                  };
                }()));

              case 1:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      return function createSandbox(_x) {
        return _createSandbox.apply(this, arguments);
      };
    }()
  }, {
    key: "run",
    value: function run() {
      console.log('Qin is running!');
    }
  }, {
    key: "render",
    value: function render() {}
  }]);

  return Qin;
}(); // export default Qin;


exports.Qin = Qin;