"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es6.object.define-property");

require("core-js/modules/es6.promise");

require("regenerator-runtime/runtime");

var _storeUtil = require("./reduxCore/storeUtil");

var _storeActions = require("./reduxCore/actions/storeActions");

var _Shuo = _interopRequireDefault(require("./shuoCore/Shuo"));

var _DBClient = _interopRequireDefault(require("./dbCore/DBClient"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var QinSandbox =
/*#__PURE__*/
function () {
  function QinSandbox(props) {
    _classCallCheck(this, QinSandbox);

    _defineProperty(this, "_shuo", void 0);

    _defineProperty(this, "_store", void 0);

    _defineProperty(this, "_dbCore", void 0);

    _defineProperty(this, "_isDebugRedux", void 0);

    this._isDebugRedux = props.isDebugRedux || false;
    this._shuo = new _Shuo.default();
  }

  _createClass(QinSandbox, [{
    key: "init",
    value: function () {
      var _init = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(name) {
        var _this = this;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                return _context2.abrupt("return", new Promise(
                /*#__PURE__*/
                function () {
                  var _ref = _asyncToGenerator(
                  /*#__PURE__*/
                  regeneratorRuntime.mark(function _callee(resolve, reject) {
                    return regeneratorRuntime.wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            _context.prev = 0;

                            _this._initRedux(_this._isDebugRedux);

                            _context.next = 4;
                            return _this._initShuo();

                          case 4:
                            _context.next = 6;
                            return _this._initPouchDB(name);

                          case 6:
                            resolve();
                            _context.next = 12;
                            break;

                          case 9:
                            _context.prev = 9;
                            _context.t0 = _context["catch"](0);
                            reject(_context.t0);

                          case 12:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee, this, [[0, 9]]);
                  }));

                  return function (_x2, _x3) {
                    return _ref.apply(this, arguments);
                  };
                }()));

              case 1:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      return function init(_x) {
        return _init.apply(this, arguments);
      };
    }()
  }, {
    key: "_initRedux",
    value: function _initRedux(isDebugRedux) {
      var _this2 = this;

      this._store = (0, _storeUtil.initStore)(isDebugRedux);

      this._store.subscribe(function () {
        return console.log(_this2._store.getState());
      });

      this._store.dispatch((0, _storeActions.storeInit)());
    }
  }, {
    key: "_initShuo",
    value: function () {
      var _initShuo2 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee3() {
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this._shuo.init();

              case 2:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      return function _initShuo() {
        return _initShuo2.apply(this, arguments);
      };
    }()
  }, {
    key: "_initPouchDB",
    value: function () {
      var _initPouchDB2 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee4(name) {
        var _this3 = this;

        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                return _context4.abrupt("return", new Promise(function (resolve, reject) {
                  try {
                    _this3._dbCore = new _DBClient.default({
                      name: name
                    });
                    resolve();
                  } catch (e) {
                    reject(e);
                  }
                }));

              case 1:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      return function _initPouchDB(_x4) {
        return _initPouchDB2.apply(this, arguments);
      };
    }()
  }, {
    key: "loadExtra",
    value: function loadExtra(extra) {
      if (extra) {
        this._shuo.loadExtra(extra);
      }
    }
  }]);

  return QinSandbox;
}();

var _default = QinSandbox;
exports.default = _default;