"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es6.object.define-property");

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/web.dom.iterable");

var PIXI = _interopRequireWildcard(require("pixi.js"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * class for renderer
 */
var QinRenderer =
/*#__PURE__*/
function () {
  /**
   * init renderer for engine
   * @param props {RendererPropsType}
   * @param props._core {QinCore} engine core
   * @param props._canvas {HTMLElement} HTMLElement instance which will contain your renderer
   */
  function QinRenderer(props) {
    _classCallCheck(this, QinRenderer);

    _defineProperty(this, "_core", void 0);

    _defineProperty(this, "_canvasContainer", void 0);

    _defineProperty(this, "_controller", void 0);

    _defineProperty(this, "_renderer", void 0);

    _defineProperty(this, "_resources", void 0);

    _defineProperty(this, "_onAssetLoadingFinish", void 0);

    this._core = props.core;
    this._canvasContainer = props.element;
    this._controller = null;

    this._onAssetLoadingFinish = function () {};

    this._initRenderer(props);

    this._initAssetLoader();
  }
  /**
   * init renderer and stage
   * @param props {RendererPropsType}
   * @private
   */


  _createClass(QinRenderer, [{
    key: "_initRenderer",
    value: function _initRenderer(props) {
      var width = props.width,
          height = props.height;
      this._renderer = new PIXI.Application(width, height, {
        backgroundColor: 0xeeeeee
      }); // this._controller = new Controller({
      // 	mouse: new Mouse({
      // 		hitArea: new PIXI.Rectangle(0, 0, width, height),
      // 	}).init(),
      // });
      // this._stageAgent = new StageAgent({renderer: this._renderer, controller: this._controller});
      //
      // this._stageAgent.init();

      this._canvasContainer.appendChild(this._renderer.view);

      this._renderer.view.addEventListener('contextmenu', function (e) {
        e.preventDefault();
      });

      var basicText = new PIXI.Text('Basic text in pixi');
      basicText.x = 30;
      basicText.y = 90;

      this._renderer.stage.addChild(basicText);
    }
    /**
     * init asset loader for loading asset files
     * @todo show progress information
     * @private
     */

  }, {
    key: "_initAssetLoader",
    value: function _initAssetLoader() {
      var _this = this;

      var loader = PIXI.loader;
      loader.onProgress.add(function (e) {//console.log(e.progress);
      });
      loader.onComplete.add(function (loader, resources) {
        _this._resources = resources;

        _this._onAssetLoadingFinish();
      });
    }
  }, {
    key: "_setAssetLoadingListener",
    value: function _setAssetLoadingListener(onFinish) {
      this._onAssetLoadingFinish = onFinish;
    }
    /**
     * loading asset files to memory
     * @param assetsSet {object} static object contain files information such as path, name etc.
     * @private
     */

  }, {
    key: "_prepareAssets",
    value: function _prepareAssets(assetsSet) {
      var loader = PIXI.loader;
      loader.reset();
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = assetsSet[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var assetsData = _step.value;

          for (var asset in assetsData) {
            if (assetsData[asset].IS_CONTAIN_ANIMATION) {
              for (var animation in assetsData[asset].DATA) {
                loader.add(assetsData[asset].DATA[animation].NAME, assetsData[asset].DATA[animation].PATH);
              }
            } else {
              loader.add(assetsData[asset].DATA.NAME, assetsData[asset].DATA.PATH);
            }
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return != null) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      loader.load();
    }
  }, {
    key: "renderScene",
    value: function renderScene(scene) {
      scene._setRenderer(this); // this._setAssetLoadingListener(scene.onAssetsFinish());
      // this._prepareAssets(scene.getAssetsDate());


      return this;
    }
  }, {
    key: "render",
    value: function render() {}
  }]);

  return QinRenderer;
}();

var _default = QinRenderer;
exports.default = _default;